const CACHE_NAME = "v01::GRAWITACJA";

let CACHED_FILES = [
  './index.html',
  './explain.html',
  './css/Proca.css',
  './js/procaG.js',
  './img/EarthSmall.jpg'
];

self.addEventListener('install', function (event) {
  console.log('WORKER: trwa instalacja.');
  for (let item of CACHED_FILES){
    console.log("rejestruje: " + item);
  }
  event.waitUntil(
    caches.open(CACHE_NAME)
    .then(function (cache) {
      return cache.addAll(CACHED_FILES);
    })
    .then(function() {
      console.log('WORKER: instalacja zakonczona');
    })
    .catch(function (err) {
      console.error("WORKER: blad instalacji ", err);
    })
  );
});

function unableToResolve () {
  console.log('WORKER: polecenie fetch nie powiodlo sie zarowno do cache i do sieci.');
  return new Response('<h1>Serwis jest niedostępny</h1>', {
    status: 503,
    statusText: 'Service Unavailable',
    headers: new Headers({
      'Content-Type': 'text/html'
    })
  })
}

self.addEventListener('fetch', function(event) {
  event.respondWith(
    // Probujemy pobrac z cache
    caches.match(event.request).then(function(response) {
      // jak nie usa się, to probujem pobrac z sieci
      return response || fetch(event.request);
    }).catch(function() {
      return unableToResolve ();
    })
  )
});

self.addEventListener("activate", function(event) {
  console.log('WORKER: aktywacja ');
  caches.keys()
  .then(function(cacheNames) {
    return Promise.all(
      cacheNames.map(
        function(cacheName) {
          if(cacheName != CACHE_NAME) { return caches.delete(cacheName); }
      })
    )
  })
  .then(function() {
     console.log('WORKER: activate completed.');
  })
});

/*
self.addEventListener("activate", function(event) {
  console.log('WORKER: activate event in progress.');
  event.waitUntil (
    caches
      .keys()
      .then(function (keys) {
        return Promise.all(
          keys
            .filter(function (key) {
              return !key.startsWith(CACHE_NAME);
            })
            .map(function (key) {
              return caches.delete(key);
            })
        );
      })
      .then(function() {
        console.log('WORKER: activate completed.');
      })
  );
});
*/
